# -*- generated by 1.0.12 -*-
import da
PatternExpr_254 = da.pat.TuplePattern([da.pat.ConstantPattern('B'), da.pat.FreePattern('l'), da.pat.FreePattern('col')])
PatternExpr_255 = da.pat.FreePattern(None)
PatternExpr_277 = da.pat.TuplePattern([da.pat.ConstantPattern('B'), da.pat.FreePattern('l'), da.pat.FreePattern('col')])
PatternExpr_294 = da.pat.TuplePattern([da.pat.ConstantPattern('A'), da.pat.FreePattern('l'), da.pat.FreePattern('lin')])
_config_object = {}
import numpy as np

class PA(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([])

    def setup(self, calcul, A, **rest_384):
        super().setup(calcul=calcul, A=A, **rest_384)
        self._state.calcul = calcul
        self._state.A = A
        pass

    def run(self):
        for l in range(len(self._state.A)):
            print('A: ', l)
            self.send(('A', l, self._state.A[l]), to=self._state.calcul)

class PB(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([])

    def setup(self, calcul, B, **rest_384):
        super().setup(calcul=calcul, B=B, **rest_384)
        self._state.calcul = calcul
        self._state.B = B
        pass

    def run(self):
        for c in range(len(self._state.B.T)):
            print('B: ', c)
            self.send(('B', c, self._state.B.T[c]), to=self._state.calcul)

class CALCUL(da.DistProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._CALCULReceivedEvent_0 = []
        self._events.extend([da.pat.EventPattern(da.pat.ReceivedEvent, '_CALCULReceivedEvent_0', PatternExpr_254, sources=[PatternExpr_255], destinations=None, timestamps=None, record_history=True, handlers=[]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CALCULReceivedEvent_1', PatternExpr_277, sources=None, destinations=None, timestamps=None, record_history=None, handlers=[self._CALCUL_handler_276]), da.pat.EventPattern(da.pat.ReceivedEvent, '_CALCULReceivedEvent_2', PatternExpr_294, sources=None, destinations=None, timestamps=None, record_history=None, handlers=[self._CALCUL_handler_293])])

    def setup(self, neighbour, x, **rest_384):
        super().setup(neighbour=neighbour, x=x, **rest_384)
        self._state.neighbour = neighbour
        self._state.x = x
        pass

    def run(self):
        super()._label('_st_label_239', block=False)
        col = l = None

        def ExistentialOpExpr_240():
            nonlocal col, l
            for (_, _, (_ConstantPattern264_, l, col)) in self._CALCULReceivedEvent_0:
                if (_ConstantPattern264_ == 'B'):
                    if True:
                        return True
            return False
        _st_label_239 = 0
        while (_st_label_239 == 0):
            _st_label_239 += 1
            if ExistentialOpExpr_240():
                _st_label_239 += 1
            else:
                super()._label('_st_label_239', block=True)
                _st_label_239 -= 1
        print('RECEIVED in B : ', l)

    def _CALCUL_handler_276(self, l, col):
        print('RECEIVED out B : ', l, col)
    _CALCUL_handler_276._labels = None
    _CALCUL_handler_276._notlabels = None

    def _CALCUL_handler_293(self, l, lin):
        print('RECEIVED out A : ', l, lin)
    _CALCUL_handler_293._labels = None
    _CALCUL_handler_293._notlabels = None

class Node_(da.NodeProcess):

    def __init__(self, procimpl, props):
        super().__init__(procimpl, props)
        self._events.extend([])

    def run(self):
        pb = 0
        A = np.array([[1, 2], [3, 4]])
        B = np.array([[1, 2], [3, 4]])
        calcul = self.new(CALCUL)
        pa = self.new(PA)
        pb = self.new(PB)
        self._setup(calcul, (pa, 5))
        self._setup(pa, (calcul, A))
        self._setup(pb, (calcul, B))
        self._start(calcul)
        self._start(pa)
        self._start(pb)
